# Copyright (C) 1998,1999,2000 by the Free Software Foundation, Inc.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software 
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

"""Mixin class for configuring Usenet gateway.

All the actual functionality is in Handlers/ToUsenet.py for the mail->news
gateway and cron/gate_news for the news->mail gateway.

"""

from Mailman import mm_cfg



class GatewayManager:
    def InitVars(self):
        # Configurable
        self.nntp_host        = mm_cfg.DEFAULT_NNTP_HOST
        self.linked_newsgroup = ''
        self.gateway_to_news  = 0
        self.gateway_to_mail  = 0

    def GetConfigInfo(self):
        WIDTH = mm_cfg.TEXTFIELDWIDTH

        return [
            '᡼롦˥塼ӥ.',
            ('nntp_host', mm_cfg.String, WIDTH, 0,
             '˥塼ФưƤޥΥ󥿡ͥå'
             'ɥ쥹.',
             '˥塼Ф Mailman εǽǤϤޤ'
             'ʤϴ NNTP Ф˥äƤ'
             'ɬפꡤ NNTPФϥ᡼󥰥ꥹȤưƤ'
             'ޥ֥˥塼ɤ߽񤭤ǤۥȡפǧʤФʤޤ'),

            ('linked_newsgroup', mm_cfg.String, WIDTH, 0,
              'Ԥ Usenet Υ˥塼롼̾'),

            ('gateway_to_news',  mm_cfg.Toggle, ('No', 'Yes'), 0,
             '᡼󥰥ꥹȤؤƤ˥塼롼פžޤ?'),

            ('gateway_to_mail',  mm_cfg.Toggle, ('No', 'Yes'), 0,
             '˥塼롼פؤƤ᡼󥰥ꥹȤžޤ?'),

            ('_mass_catchup', mm_cfg.Toggle, ('No', 'Yes'), 0,
             '˥塼롼פ <em>catchup</em> ޤ?',
             '''catchup ȤȤϡοƤä
             ž򳫻ϤȤȤǤ
             Υ˥塼롼פε̵뤵ޤ
             ϡʤȤ˥塼ɤǤơߤ
             ִɡפˤΤƱȤǤ
             Catchup ȥ᡼󥰥ꥹȤΥСϰΥå
             뤳ȤϤޤ.''')
            ]
